package io.github.taha_cmd.api.http;

import io.github.taha_cmd.SignPathClientSimpleLogger;
import okhttp3.OkHttpClient;
import okhttp3.Response;

import java.util.concurrent.TimeUnit;
import java.util.function.Function;

public class HttpClientFactory {

    public static okhttp3.OkHttpClient createHttpClient(int numberOfRetries,
                                                        int requestTimeoutInSeconds,
                                                        SignPathClientSimpleLogger logger,
                                                        Function<Response, String> errorMessageFormatter) {
        return new OkHttpClient.Builder()
                .connectTimeout(requestTimeoutInSeconds, TimeUnit.SECONDS)
                .readTimeout(requestTimeoutInSeconds, TimeUnit.SECONDS)
                .writeTimeout(requestTimeoutInSeconds, TimeUnit.SECONDS)
                .callTimeout(requestTimeoutInSeconds, TimeUnit.SECONDS)
                .addInterceptor(new HttpClientRetryInterceptor(numberOfRetries, logger, errorMessageFormatter))
                .build();
    }
}
